"use strict";
exports.__esModule = true;
exports.generator = void 0;
var validator_1 = require("./validator");
var generator = function (values) {
    var record = [];
    if (values.v == undefined) {
        throw new Error("DMARC Version is required tag");
    }
    validator_1.validators.v.validate.call(validator_1.validators.v, "v", values.v);
    record.push("v=" + values.v);
    for (var i = 0; i < Object.keys(values).length; i++) {
        var term = Object.keys(values)[i];
        if (term === "v")
            continue;
        if (validator_1.validators[term]) {
            var settings = validator_1.validators[term];
            var value = null;
            if (settings.generate) {
                value = settings.generate(values[term]);
            }
            else
                value = values[term];
            settings.validate.call(settings, term, value);
            record.push(term + "=" + value);
        }
    }
    return record.join("; ");
};
exports.generator = generator;
